"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var key in props) { var prop = props[key]; prop.configurable = true; if (prop.value) prop.writable = true; } Object.defineProperties(target, props); } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var LevelPromisify = (function () {
    function LevelPromisify(db, opts) {
        _classCallCheck(this, LevelPromisify);

        this.root = db;
        return this;
    }

    _createClass(LevelPromisify, {
        put: {
            value: function put(key, value, opts) {
                var _this = this;

                if (opts) {
                    opts.sync = false;
                }

                return new Promise(function (resolve, reject) {
                    _this.root.put(key, value, opts, function (err) {
                        if (err) return reject(err);
                        resolve(_this);
                    });
                });
            }
        },
        get: {
            value: function get(key, opts) {
                var _this = this;

                return new Promise(function (resolve, reject) {
                    _this.root.get(key, opts, function (err, res) {
                        if (err) return reject(err);
                        resolve(res);
                    });
                });
            }
        },
        del: {
            value: function del(key, opts) {
                var _this = this;

                if (opts) {
                    opts.sync = false;
                }

                return new Promise(function (resolve, reject) {
                    _this.root.del(key, opts, function (err) {
                        if (err) return reject(err);
                        resolve(_this);
                    });
                });
            }
        },
        batch: {
            value: function batch(ops, opts) {
                var _this = this;

                if (opts) {
                    opts.sync = false;
                }

                return new Promise(function (resolve, reject) {
                    _this.root.batch(ops, opts, function (err) {
                        if (err) return reject(err);
                        resolve(_this);
                    });
                });
            }
        },
        close: {
            value: function close() {
                this.root.close();
            }
        }
    });

    return LevelPromisify;
})();

module.exports = function (db, opts) {
    return new LevelPromisify(db, opts);
};